<?php
// $Id: filemime.inc,v 1.1.2.1 2008/06/11 20:56:10 mfb Exp $

/**
 * Return a MIME type given a file name.
 */
function filemime_from_name($name) {
  return preg_match('/\.([a-zA-Z0-9]+)$/', $name, $matches) ? filemime_from_extension($matches[1]) : FALSE;
}

/**
 * Return a MIME type given a file extension.
 */
function filemime_from_extension($extension) {
  static $mime_types = array();
  if (empty($mime_types)) {
    $file = variable_get('filemime_file', '/usr/local/etc/apache22/mime.types');
    $lines = array_merge(
      is_readable($file) ? file($file) : array(),
      preg_split('/[\n\r]+/', variable_get('filemime_types', ''), -1, PREG_SPLIT_NO_EMPTY)
    );
    foreach ($lines as $line) {
      $types = preg_split('/[\s]+/', $line, -1, PREG_SPLIT_NO_EMPTY);
      foreach ($types as $index => $type) {
        if (substr($type, 0, 1) == '#') {
          break;
        }
        if ($index) {
          $mime_types[$type] = $types[0];
        }
      }
    }    
  }
  return empty($mime_types[$extension]) ? FALSE : $mime_types[$extension];
}
